#include <fpp.h>
#include <xerrno.h>


#if STDC
void
error(const char *msg1, const char *msg2, const char *msg3, int dump_lineno)
#else /* NOT STDC */
void
error(msg1, msg2, msg3, dump_lineno)
const char *msg1;
const char *msg2;
const char *msg3;
int dump_lineno;
#endif /* STDC */
{
    int k;

    FPRINTF(stderr,"%s:%s%s%s%s",
	    fpp_dbgprefix(), ERR_PREFIX, msg1, msg2, msg3);
    if (dump_lineno && (level > 0))
    {
	for (k = 1; k <= level; ++k)
	    FPRINTF(stderr," %d",lineno[k]);
    }
    else if (dump_lineno && (level < 0))
    {
	for (k = 1; k > level; --k)
	    FPRINTF(stderr," %d",lineno[k]);
    }
    FPRINTF(stderr,"\n");
    FPRINTF(stderr,"%s:%sInput line = [%s]\n",
	    fpp_dbgprefix(), ERR_PREFIX, fpp_line);
    if (errno)
    {
	SPRINTF(err_line,"%s:%sperror() says", fpp_dbgprefix(), ERR_PREFIX);
	perror(err_line);
	errno = 0;
    }
    FFLUSH(stderr);
    fpp_code = EXIT_FAILURE;
}
