#include <fpp.h>

#if defined(HAVE_MATH_H)
#include <math.h>
#endif

#define MATCH(s)	(strcmp(s,op) == 0)

static double fpp_xor ARGS((double a, double b));

const char *
expr(VOID_ARG)
{
    const char* e;
    const char* op;
    double t1;
    double t2;

    e = term();
    while (ke < ne)
    {
	op = ee[ke++];
	if (MATCH("+"))
	    e = dtos((double)(atof(e) + atof(term())));
	else if (MATCH("-"))
	    e = dtos((double)(atof(e) - atof(term())));
	else if (MATCH("|"))		/* we need to force evaluation */
	{				/* of both sides so ke advances! */
	    t1 = atof(e);
	    t2 = atof(term());
	    e = dtos((double)((t1 != 0.0) || (t2 != 0.0)));
	}
	else if (MATCH("&"))		/* we need to force evaluation */
	{				/* of both sides so ke advances! */
	    t1 = atof(e);
	    t2 = atof(term());
	    e = dtos((double)((t1 != 0.0) && (t2 != 0.0)));
	}
	else if (MATCH(".neqv."))
	    e = dtos((double)(fpp_xor(atof(e),atof(term()))));
	else if (MATCH(".eqv."))
	    e = dtos((double)(!fpp_xor(atof(e),atof(term()))));
	else if (MATCH("=="))
	    e = dtos((double)(atof(e) == atof(term())));
	else if (MATCH("!="))
	    e = dtos((double)(atof(e) != atof(term())));
	else if (MATCH("<="))
	    e = dtos((double)(atof(e) <= atof(term())));
	else if (MATCH(">="))
	    e = dtos((double)(atof(e) >= atof(term())));
	else if (MATCH("<"))
	    e = dtos((double)(atof(e) < atof(term())));
	else if (MATCH(">"))
	    e = dtos((double)(atof(e) > atof(term())));
	else
	{
	    ke--;		/* just have bare term; backup one entry */
	    break;
	}
    }
    return e;
}


#if STDC
static double
fpp_xor(double a, double b)
#else /* NOT STDC */
static double
fpp_xor(a,b)
double a;
double b;
#endif /* STDC */
{
    /* This function used to be called xor(), but C++ reserves that
       name for an operator name, and g++ 3.0 refuses to allow the
       preprocessor to redefine xor to something else, sigh... */
    return (((int)a && !(int)b) || (!(int)a && (int)b)) ? 1 : 0;
}
