#include <fpp.h>
#include <xerrno.h>

#undef EXTERN
#define EXTERN
#include <hash.h>
#undef EXTERN

#if defined(HAVE_TIME_H)
#include <time.h>
#endif

#if defined(HAVE_SYS_TYPES_H)
#include <sys/types.h>
#endif

char		*Cuserid ARGS((char *s));

#include <xpwd.h>			/* for passwd  */

struct passwd	*passwdp;

char fpp_hostname[MAXLINE+1] = "unknown-hostname";
char fpp_timestamp[] = "Mon Dec 24 15:44:14 MST 1990";
CPPEXTERN const char *fpp_cwd = "";
CPPEXTERN const char *fpp_personal_name = "";
CPPEXTERN const char *fpp_user_name = "";

#undef EXTERN

void
init(VOID_ARG)
{
    char date[sizeof("Jul 24 1847")];
    char fpp_timezone[sizeof("GMT")];
    char iso_date[sizeof("1847-07-24")];
    static char months[] = "Jan.Feb.Mar.Apr.May.Jun.Jul.Aug.Sep.Oct.Nov.Dec.";
    int n;
    char *p;
    const char *q;

#if    OS_VMCMS
    struct tm			*thetimeval;
				/* clock value from time() for ctime() */
#else /* NOT OS_VMCMS */
    time_t			thetimeval;
				/* clock value from time() for ctime() */
#endif /* OS_VMCMS */

    errno = 0;
    fpp_code = EXIT_SUCCESS;
    fpp_debug = 0;
    fpp_infile = (FILE*)NULL;
    fpp_name = "unknown";
    g_src_form = src_form = SF_UNKNOWN;
    level = 0;
    out_prefix = OUT_FIXED_PREFIX;
    src_line_length = 72;

    branch_done[0] = 1;			/* ensure at least one element is set */
    selected[0] = 1;

    for (n = 1; n < MAXLEVEL; ++n)
    {
	selected[n] = 0;
	branch_done[n] = 0;
    }

#if    OS_VMCMS
    thetimeval = time();
    (void)strcpy(fpp_timestamp,ctime(thetimeval));
#else  /* NOT OS_VMCMS */
    thetimeval = time((time_t*)NULL);
    (void)strcpy(fpp_timestamp,ctime(&thetimeval));
#endif /* OS_VMCMS */

    /* 000000000011111111112222 2 2 */
    /* 012345678901234567890123 4 5 */
    /* Mon Dec 24 15:44:14 1990\n\0 */

    fpp_timestamp[24] = '\0';		/* remove final newline */

    date[0] = fpp_timestamp[4];		/* form "Dec 24 1990" */
    date[1] = fpp_timestamp[5];		/*       01234567890 */
    date[2] = fpp_timestamp[6];
    date[3] = fpp_timestamp[7];
    date[4] = fpp_timestamp[8];
    date[5] = fpp_timestamp[9];
    date[6] = fpp_timestamp[10];
    date[7] = fpp_timestamp[20];
    date[8] = fpp_timestamp[21];
    date[9] = fpp_timestamp[22];
    date[10] = fpp_timestamp[23];
    date[11] = '\0';

    iso_date[0] = fpp_timestamp[20];
    iso_date[1] = fpp_timestamp[21];
    iso_date[2] = fpp_timestamp[22];
    iso_date[3] = fpp_timestamp[23];
    iso_date[4] = '-';
    iso_date[5] = ' ';
    iso_date[6] = ' ';
    iso_date[7] = '-';
    iso_date[8] = fpp_timestamp[8];
    iso_date[9] = fpp_timestamp[9];

    fpp_timestamp[7] = '\0';
    q = (const char*)strstr(months, &fpp_timestamp[4]);
    fpp_timestamp[7] = ' ';

    if (q != (const char*)NULL)
    {
	n = 1 + (q - &months[0])/4;
	(void)sprintf(&iso_date[5],"%02d",n);
	iso_date[7] = '-';
    }

    fpp_timezone[0] = '\0';

#if !defined(__TURBOC__)
#if STDC
#if defined(_AIX370) && defined(__cplusplus)
    /* prototype for strftime() in /usr/local/lib/CC-include/time.h is wrong */
#if defined(HAVE_DAYLIGHT) && defined(HAVE_TZNAME)
    tzset();			/* set daylight and tzname externals */
    (void)strncpy(fpp_timezone,daylight ? tzname[1] : tzname[0],3);
#endif
#else
#if defined(HAVE_STRFTIME_PROTOTYPE)
    (void)strftime(fpp_timezone,4,"%Z",localtime(&thetimeval));
#endif
#endif /* defined(_AIX370) && defined(__cplusplus) */
#else /* NOT STDC */
#if defined(HAVE_UUTM_ZONE_MEMBER)
#define tm_zone __tm_zone	/* Compaq/DEC OSF/1 has __tm_zone */
#endif
#if defined(HAVE_TM_ZONE_MEMBER)
    (void)strncpy(fpp_timezone,localtime(&thetimeval)->tm_zone,3);
#else
#if defined(HAVE_DAYLIGHT) && defined(HAVE_TZNAME)
    tzset();			/* set daylight and tzname externals */
    (void)strncpy(fpp_timezone,daylight ? tzname[1] : tzname[0],3);
#endif
#endif /* defined(HAVE_TM_ZONE_MEMBER) */
#endif /* STDC */
#endif /* !defined(__TURBOC__) */

    fpp_timezone[3] = '\0';

    /* In order to prevent command-line definition of the six permanent
       symbols, we create initial definitions of them, with empty values
       if no suitable initial value is available */

    dodef2("__FILE__","",1);
    dodef2("__ISO_DATE__",iso_date,1);
    dodef2("__LINE__","",1);
    dodef2("__TIMEZONE__",fpp_timezone,1);

    fpp_timestamp[19] = '\0';
    dodef2("__DATE__",date,1);
    dodef2("__TIME__",&fpp_timestamp[11],1);
    fpp_timestamp[19] = ' ';

    /* To reduce hash and malloc activity, we put the hash value of
       __LINE__ in global storage; it gets updated in getline() */

    n = install("__LINE__","");
    if (n >= 0)
    {
	free((void*)hash_value[n]);
	hash_value[n] = fpp_number;
    }
    FNR = 0;
    NR = 0;

    /* We prefer the value of the environment variable PWD to that
       returned by getcwd(), because the latter often shows NFS mount
       points, instead of a shorter, more familiar, path. */
    p = getenv("PWD");
    if (p == (char*)NULL)
	p = getcwd(fpp_line,sizeof(fpp_line));
    fpp_cwd = concat("",p);

#if defined(HAVE_GETLOGIN_PROTOTYPE)
    /* output Jill Q. Username <user_name@machine.site.org> */
    fpp_user_name = getlogin();
    if ( (fpp_user_name == (const char*)NULL) || (fpp_user_name[0] == '\0') )
	fpp_user_name = (const char*)Cuserid((char*)NULL);
    passwdp = (struct passwd*)getpwuid(getuid());
    if (passwdp != (struct passwd *)NULL)
    {
#if defined(HAVE_PW_NAME)
	if ( (fpp_user_name == (const char*)NULL) || (fpp_user_name[0] == '\0') )
	    fpp_user_name = passwdp->pw_name;
#endif
#if defined(HAVE_PW_GECOS)
	if (passwdp->pw_gecos[0] == '&')
	    fpp_personal_name = fpp_user_name;		/* & means use login name */
	else
	    fpp_personal_name = passwdp->pw_gecos;	/* have personal name */
#endif

#if __convex__ || __sgi
	/* Convex and SGI store "John Doe, office, phone" in
	   /etc/passwd entry */
	if (fpp_personal_name != (char*)NULL)
	{
	    p = strchr(fpp_personal_name,',');
	    if (p != (char*)NULL)
	        *p = '\0';
	}
#endif

    }
    if ( (fpp_user_name == (const char*)NULL) || (fpp_user_name[0] == '\0') )
	fpp_user_name = (const char*)getenv("USER");
    if ( (fpp_user_name == (const char*)NULL) || (fpp_user_name[0] == '\0') )
        fpp_user_name = "";
    if (gethostname(fpp_hostname,sizeof(fpp_hostname)) == 0)
	fpp_hostname[sizeof(fpp_hostname)-1] = '\0'; /* ensure final NULL */
    else
    {
	p = getenv("HOST");
	if (p != (char*)NULL)
	    p = getenv("HOSTNAME");
	if (p != (char*)NULL)
	{
	    (void)strncpy(fpp_hostname,p,sizeof(fpp_hostname));
	    fpp_hostname[sizeof(fpp_hostname)-1] = '\0'; /* ensure final NULL */
	}
	else				/* no hostname available */
	    fpp_hostname[0] = '\0';
    }

#endif /* defined(HAVE_GETLOGIN_PROTOTYPE) */

    errno = 0;				/* clear again, because gethostname()
					   on IBM AIX sets errno == EACCES */
}
